diff --git a/python/configobj/configobj.py b/python/configobj/configobj.py
index c1f6e6df86..1135cbd2cd 100644
--- a/python/configobj/configobj.py
+++ b/python/configobj/configobj.py
@@ -161,7 +161,7 @@ class Builder(object):
         return m(o)
     
     def build_List(self, o):
-        return map(self.build, o.getChildren())
+        return list(map(self.build, o.getChildren()))
     
     def build_Const(self, o):
         return o.value
@@ -170,7 +170,7 @@ class Builder(object):
         d = {}
         i = iter(map(self.build, o.getChildren()))
         for el in i:
-            d[el] = i.next()
+            d[el] = next(i)
         return d
     
     def build_Tuple(self, o):
@@ -188,7 +188,7 @@ class Builder(object):
         raise UnknownType('Undefined Name')
     
     def build_Add(self, o):
-        real, imag = map(self.build_Const, o.getChildren())
+        real, imag = list(map(self.build_Const, o.getChildren()))
         try:
             real = float(real)
         except TypeError:
@@ -518,7 +518,7 @@ class Section(dict):
         self._initialise()
         # we do this explicitly so that __setitem__ is used properly
         # (rather than just passing to ``dict.__init__``)
-        for entry, value in indict.iteritems():
+        for entry, value in indict.items():
             self[entry] = value
             
             
@@ -566,11 +566,11 @@ class Section(dict):
         """Fetch the item and do string interpolation."""
         val = dict.__getitem__(self, key)
         if self.main.interpolation: 
-            if isinstance(val, basestring):
+            if isinstance(val, str):
                 return self._interpolate(key, val)
             if isinstance(val, list):
                 def _check(entry):
-                    if isinstance(entry, basestring):
+                    if isinstance(entry, str):
                         return self._interpolate(key, entry)
                     return entry
                 new = [_check(entry) for entry in val]
@@ -593,7 +593,7 @@ class Section(dict):
         ``unrepr`` must be set when setting a value to a dictionary, without
         creating a new sub-section.
         """
-        if not isinstance(key, basestring):
+        if not isinstance(key, str):
             raise ValueError('The key "%s" is not a string.' % key)
         
         # add the comment
@@ -627,11 +627,11 @@ class Section(dict):
             if key not in self:
                 self.scalars.append(key)
             if not self.main.stringify:
-                if isinstance(value, basestring):
+                if isinstance(value, str):
                     pass
                 elif isinstance(value, (list, tuple)):
                     for entry in value:
-                        if not isinstance(entry, basestring):
+                        if not isinstance(entry, str):
                             raise TypeError('Value is not a string "%s".' % entry)
                 else:
                     raise TypeError('Value is not a string "%s".' % value)
@@ -721,7 +721,7 @@ class Section(dict):
 
     def items(self):
         """D.items() -> list of D's (key, value) pairs, as 2-tuples"""
-        return zip((self.scalars + self.sections), self.values())
+        return list(zip((self.scalars + self.sections), list(self.values())))
 
 
     def keys(self):
@@ -741,7 +741,7 @@ class Section(dict):
 
     def iterkeys(self):
         """D.iterkeys() -> an iterator over the keys of D"""
-        return iter((self.scalars + self.sections))
+        return iter(self.scalars + self.sections)
 
     __iter__ = iterkeys
 
@@ -972,7 +972,7 @@ class Section(dict):
             return False
         else:
             try:
-                if not isinstance(val, basestring):
+                if not isinstance(val, str):
                     # TODO: Why do we raise a KeyError here?
                     raise KeyError()
                 else:
@@ -1243,7 +1243,7 @@ class ConfigObj(Section):
         
         
     def _load(self, infile, configspec):
-        if isinstance(infile, basestring):
+        if isinstance(infile, str):
             self.filename = infile
             if os.path.isfile(infile):
                 h = open(infile, 'rb')
@@ -1453,6 +1453,11 @@ class ConfigObj(Section):
             return self._decode(infile, self.encoding)
         
         # No encoding specified - so we need to check for UTF8/UTF16
+        if not isinstance(line, bytes):
+            # Already decoded text (Python 3); no BOM to check
+            if isinstance(infile, (list, tuple)):
+                return infile
+            return infile.splitlines(True)
         for BOM, (encoding, final_encoding) in BOMS.items():
             if not line.startswith(BOM):
                 continue
@@ -1469,7 +1474,7 @@ class ConfigObj(Section):
                     else:
                         infile = newline
                     # UTF8 - don't decode
-                    if isinstance(infile, basestring):
+                    if isinstance(infile, str):
                         return infile.splitlines(True)
                     else:
                         return infile
@@ -1477,7 +1482,7 @@ class ConfigObj(Section):
                 return self._decode(infile, encoding)
             
         # No BOM discovered and no encoding specified, just return
-        if isinstance(infile, basestring):
+        if isinstance(infile, str):
             # infile read from a file will be a single string
             return infile.splitlines(True)
         return infile
@@ -1497,12 +1502,12 @@ class ConfigObj(Section):
         
         if is a string, it also needs converting to a list.
         """
-        if isinstance(infile, basestring):
+        if isinstance(infile, str):
             # can't be unicode
             # NOTE: Could raise a ``UnicodeDecodeError``
             return infile.decode(encoding).splitlines(True)
         for i, line in enumerate(infile):
-            if not isinstance(line, unicode):
+            if not isinstance(line, str):
                 # NOTE: The isinstance test here handles mixed lists of unicode/string
                 # NOTE: But the decode will break on any non-string values
                 # NOTE: Or could raise a ``UnicodeDecodeError``
@@ -1524,7 +1529,7 @@ class ConfigObj(Section):
         Used by ``stringify`` within validate, to turn non-string values
         into strings.
         """
-        if not isinstance(value, basestring):
+        if not isinstance(value, str):
             return str(value)
         else:
             return value
@@ -1641,7 +1646,7 @@ class ConfigObj(Section):
                             comment = ''
                             try:
                                 value = unrepr(value)
-                            except Exception, e:
+                            except Exception as e:
                                 if type(e) == UnknownType:
                                     msg = 'Unknown name or type in value at line %s.'
                                 else:
@@ -1654,7 +1659,7 @@ class ConfigObj(Section):
                         comment = ''
                         try:
                             value = unrepr(value)
-                        except Exception, e:
+                        except Exception as e:
                             if isinstance(e, UnknownType):
                                 msg = 'Unknown name or type in value at line %s.'
                             else:
@@ -1777,7 +1782,7 @@ class ConfigObj(Section):
                 return self._quote(value[0], multiline=False) + ','
             return ', '.join([self._quote(val, multiline=False)
                 for val in value])
-        if not isinstance(value, basestring):
+        if not isinstance(value, str):
             if self.stringify:
                 value = str(value)
             else:
@@ -1929,11 +1934,11 @@ class ConfigObj(Section):
                                        raise_errors=True,
                                        file_error=True,
                                        _inspec=True)
-            except ConfigObjError, e:
+            except ConfigObjError as e:
                 # FIXME: Should these errors have a reference
                 #        to the already parsed ConfigObj ?
                 raise ConfigspecError('Parsing configspec failed: %s' % e)
-            except IOError, e:
+            except IOError as e:
                 raise IOError('Reading configspec failed: %s' % e)
         
         self.configspec = configspec
@@ -2189,7 +2194,7 @@ class ConfigObj(Section):
                                         val,
                                         missing=missing
                                         )
-            except validator.baseErrorClass, e:
+            except validator.baseErrorClass as e:
                 if not preserve_errors or isinstance(e, self._vdtMissingValue):
                     out[entry] = False
                 else:
@@ -2338,7 +2343,7 @@ class ConfigObj(Section):
         This method raises a ``ReloadError`` if the ConfigObj doesn't have
         a filename attribute pointing to a file.
         """
-        if not isinstance(self.filename, basestring):
+        if not isinstance(self.filename, str):
             raise ReloadError()
 
         filename = self.filename
diff --git a/python/configobj/validate.py b/python/configobj/validate.py
index 73dbdb891b..ee3a55dff3 100644
--- a/python/configobj/validate.py
+++ b/python/configobj/validate.py
@@ -284,7 +284,7 @@ def dottedQuadToNum(ip):
     except socket.error:
         # bug in inet_aton, corrected in Python 2.4
         if ip.strip() == '255.255.255.255':
-            return 0xFFFFFFFFL
+            return 0xFFFFFFFF
         else:
             raise ValueError('Not a good dotted-quad IP: %s' % ip)
     return
@@ -316,11 +316,11 @@ def numToDottedQuad(num):
     import socket, struct
     
     # no need to intercept here, 4294967295L is fine
-    if num > 4294967295L or num < 0:
+    if num > 4294967295 or num < 0:
         raise ValueError('Not a good numeric IP: %s' % num)
     try:
         return socket.inet_ntoa(
-            struct.pack('!L', long(num)))
+            struct.pack('!L', int(num)))
     except (socket.error, struct.error, OverflowError):
         raise ValueError('Not a good numeric IP: %s' % num)
 
@@ -736,10 +736,10 @@ def _is_num_param(names, values, to_float=False):
     for (name, val) in zip(names, values):
         if val is None:
             out_params.append(val)
-        elif isinstance(val, (int, long, float, basestring)):
+        elif isinstance(val, (int, int, float, str)):
             try:
                 out_params.append(fun(val))
-            except ValueError, e:
+            except ValueError as e:
                 raise VdtParamError(name, val)
         else:
             raise VdtParamError(name, val)
@@ -793,9 +793,9 @@ def is_integer(value, min=None, max=None):
     0
     """
     (min_val, max_val) = _is_num_param(('min', 'max'), (min, max))
-    if not isinstance(value, (int, long, basestring)):
+    if not isinstance(value, (int, int, str)):
         raise VdtTypeError(value)
-    if isinstance(value, basestring):
+    if isinstance(value, str):
         # if it's a string - does it represent an integer ?
         try:
             value = int(value)
@@ -845,7 +845,7 @@ def is_float(value, min=None, max=None):
     """
     (min_val, max_val) = _is_num_param(
         ('min', 'max'), (min, max), to_float=True)
-    if not isinstance(value, (int, long, float, basestring)):
+    if not isinstance(value, (int, int, float, str)):
         raise VdtTypeError(value)
     if not isinstance(value, float):
         # if it's a string - does it represent a float ?
@@ -910,7 +910,7 @@ def is_boolean(value):
     VdtTypeError: the value "up" is of the wrong type.
     
     """
-    if isinstance(value, basestring):
+    if isinstance(value, str):
         try:
             return bool_dict[value.lower()]
         except KeyError:
@@ -953,7 +953,7 @@ def is_ip_addr(value):
     Traceback (most recent call last):
     VdtTypeError: the value "0" is of the wrong type.
     """
-    if not isinstance(value, basestring):
+    if not isinstance(value, str):
         raise VdtTypeError(value)
     value = value.strip()
     try:
@@ -995,7 +995,7 @@ def is_list(value, min=None, max=None):
     VdtTypeError: the value "12" is of the wrong type.
     """
     (min_len, max_len) = _is_num_param(('min', 'max'), (min, max))
-    if isinstance(value, basestring):
+    if isinstance(value, str):
         raise VdtTypeError(value)
     try:
         num_members = len(value)
@@ -1064,7 +1064,7 @@ def is_string(value, min=None, max=None):
     Traceback (most recent call last):
     VdtValueTooLongError: the value "1234" is too long.
     """
-    if not isinstance(value, basestring):
+    if not isinstance(value, str):
         raise VdtTypeError(value)
     (min_len, max_len) = _is_num_param(('min', 'max'), (min, max))
     try:
@@ -1170,7 +1170,7 @@ def is_string_list(value, min=None, max=None):
     Traceback (most recent call last):
     VdtTypeError: the value "hello" is of the wrong type.
     """
-    if isinstance(value, basestring):
+    if isinstance(value, str):
         raise VdtTypeError(value)
     return [is_string(mem) for mem in is_list(value, min, max)]
 
@@ -1278,7 +1278,7 @@ def is_mixed_list(value, *args):
     >>> res_str = "'".join(res_seq)
     >>> try:
     ...     vtor.check('mixed_list("yoda")', ('a'))
-    ... except VdtParamError, err:
+    ... except VdtParamError as err:
     ...     str(err) == res_str
     1
     """
@@ -1292,7 +1292,7 @@ def is_mixed_list(value, *args):
         raise VdtValueTooLongError(value)
     try:
         return [fun_dict[arg](val) for arg, val in zip(args, value)]
-    except KeyError, e:
+    except KeyError as e:
         raise VdtParamError('mixed_list', e)
 
 
@@ -1309,7 +1309,7 @@ def is_option(value, *options):
     Traceback (most recent call last):
     VdtTypeError: the value "0" is of the wrong type.
     """
-    if not isinstance(value, basestring):
+    if not isinstance(value, str):
         raise VdtTypeError(value)
     if not value in options:
         raise VdtValueError(value)
diff --git a/python/eme/gen-eme-voucher.py b/python/eme/gen-eme-voucher.py
index 299bc71463..57089bd27b 100644
--- a/python/eme/gen-eme-voucher.py
+++ b/python/eme/gen-eme-voucher.py
@@ -10,8 +10,8 @@
 # Creates an Adobe Access signed voucher for x32/x64 windows executables
 #   Notes: This is currently python2.7 due to mozilla build system requirements
 
-from __future__ import print_function
 
+from __future__ import print_function
 import argparse, bitstring, pprint, hashlib, os, subprocess, sys, tempfile, macholib, macholib.MachO
 from pyasn1.codec.der import encoder as der_encoder
 from pyasn1.type import univ, namedtype, namedval, constraint
@@ -129,8 +129,8 @@ def parse_items(stream, items_in, items_out):
 			bits_read += bits
 			total_bits_read += bits
 		elif len(item) == 3 or len(item) == 4:
-			requirements = list(filter(lambda x: isinstance(x, dict), item[2]))
-			sub_items = list(filter(lambda x: isinstance(x, tuple), item[2]))
+			requirements = list([x for x in item[2] if isinstance(x, dict)])
+			sub_items = list([x for x in item[2] if isinstance(x, tuple)])
 
 			if not meets_requirements(items_out, requirements): continue
 
@@ -438,8 +438,8 @@ def processMachoBinary(filename):
 
 
 
-		segment_commands = list(filter(lambda x: x[0].cmd == lc_segment, header.commands))
-		text_segment_commands = list(filter(lambda x: x[1].segname.decode("utf-8").startswith("__TEXT"), segment_commands))
+		segment_commands = list([x for x in header.commands if x[0].cmd == lc_segment])
+		text_segment_commands = list([x for x in segment_commands if x[1].segname.decode("utf-8").startswith("__TEXT")])
 
 
 		code_segment_digests = SetOfCodeSegmentDigest()
@@ -518,7 +518,7 @@ def processCOFFBinary(stream):
 
 	arch_digest.setComponentByName('cpuSubType', CPUSubType('IMAGE_UNUSED'))
 
-	text_section_headers = list(filter(lambda x: (x.items['Characteristics'] & IMAGE_SCN_MEM_EXECUTE) == IMAGE_SCN_MEM_EXECUTE, coff_header.section_headers))
+	text_section_headers = list([x for x in coff_header.section_headers if (x.items['Characteristics'] & IMAGE_SCN_MEM_EXECUTE) == IMAGE_SCN_MEM_EXECUTE])
 
 	code_segment_digests = SetOfCodeSegmentDigest()
 	code_segment_idx = 0
@@ -612,13 +612,13 @@ def main():
 			# create PEM from PFX
 			pfx_pem_path = create_temp_file(".pem")
 			temp_files += [pfx_pem_path]
-			print("Extracting PEM from PFX to:" + pfx_pem_path)
+			print(("Extracting PEM from PFX to:" + pfx_pem_path))
 			openssl_cmd(app_args, ["pkcs12", "-in", app_args.signer_pfx, "-out", pfx_pem_path], True, True)
 
 			# extract CA certs
 			pfx_cert_path = create_temp_file(".cert")
 			temp_files += [pfx_cert_path]
-			print("Extracting cert from PFX to:" + pfx_cert_path)
+			print(("Extracting cert from PFX to:" + pfx_cert_path))
 			openssl_cmd(app_args, ["pkcs12", "-in", app_args.signer_pfx, "-cacerts", "-nokeys", "-out", pfx_cert_path], True, False)
 
 			# we embed the public keychain for client validation
diff --git a/python/futures/concurrent/futures/_base.py b/python/futures/concurrent/futures/_base.py
index fbf0275120..56cd2820e6 100644
--- a/python/futures/concurrent/futures/_base.py
+++ b/python/futures/concurrent/futures/_base.py
@@ -6,6 +6,7 @@ import logging
 import threading
 import itertools
 import time
+import six
 
 __author__ = 'Brian Quinlan (brian@sweetapp.com)'
 
@@ -352,7 +353,7 @@ class Future(object):
 
     def __get_result(self):
         if self._exception:
-            raise type(self._exception), self._exception, self._traceback
+            six.reraise(type(self._exception), self._exception, self._traceback)
         else:
             return self._result
 
@@ -568,7 +569,7 @@ class Executor(object):
         if timeout is not None:
             end_time = timeout + time.time()
 
-        fs = [self.submit(fn, *args) for args in itertools.izip(*iterables)]
+        fs = [self.submit(fn, *args) for args in zip(*iterables)]
 
         # Yield must be hidden in closure so that the futures are submitted
         # before the first iterator value is required.
diff --git a/python/futures/concurrent/futures/process.py b/python/futures/concurrent/futures/process.py
index ee463f1819..ab51d9f01d 100644
--- a/python/futures/concurrent/futures/process.py
+++ b/python/futures/concurrent/futures/process.py
@@ -45,7 +45,7 @@ Process #1..n:
 
 import atexit
 from concurrent.futures import _base
-import Queue as queue
+import six.moves.queue as queue
 import multiprocessing
 import threading
 import weakref
@@ -85,20 +85,20 @@ def _python_exit():
 # (Futures in the call queue cannot be cancelled).
 EXTRA_QUEUED_CALLS = 1
 
-class _WorkItem(object):
+class _WorkItem:
     def __init__(self, future, fn, args, kwargs):
         self.future = future
         self.fn = fn
         self.args = args
         self.kwargs = kwargs
 
-class _ResultItem(object):
+class _ResultItem:
     def __init__(self, work_id, exception=None, result=None):
         self.work_id = work_id
         self.exception = exception
         self.result = result
 
-class _CallItem(object):
+class _CallItem:
     def __init__(self, work_id, fn, args, kwargs):
         self.work_id = work_id
         self.fn = fn
diff --git a/python/futures/concurrent/futures/thread.py b/python/futures/concurrent/futures/thread.py
index fa5ed0c092..38ef808e7f 100644
--- a/python/futures/concurrent/futures/thread.py
+++ b/python/futures/concurrent/futures/thread.py
@@ -5,7 +5,7 @@
 
 import atexit
 from concurrent.futures import _base
-import Queue as queue
+import six.moves.queue as queue
 import threading
 import weakref
 import sys
@@ -40,7 +40,7 @@ def _python_exit():
 
 atexit.register(_python_exit)
 
-class _WorkItem(object):
+class _WorkItem:
     def __init__(self, future, fn, args, kwargs):
         self.future = future
         self.fn = fn
diff --git a/python/futures/crawl.py b/python/futures/crawl.py
index 86e0af7fe6..7b72112b8a 100644
--- a/python/futures/crawl.py
+++ b/python/futures/crawl.py
@@ -6,7 +6,7 @@ import timeit
 import sys
 
 try:
-    from urllib2 import urlopen
+    from urllib.request import urlopen
 except ImportError:
     from urllib.request import urlopen
 
@@ -41,8 +41,8 @@ def download_urls_sequential(urls, timeout=60):
 def download_urls_with_executor(urls, executor, timeout=60):
     try:
         url_to_content = {}
-        future_to_url = dict((executor.submit(load_url, url, timeout), url)
-                             for url in urls)
+        future_to_url = {executor.submit(load_url, url, timeout): url
+                             for url in urls}
 
         for future in as_completed(future_to_url):
             try:
diff --git a/python/futures/docs/conf.py b/python/futures/docs/conf.py
index 5cea44c881..b4dbcf229d 100644
--- a/python/futures/docs/conf.py
+++ b/python/futures/docs/conf.py
@@ -1,4 +1,3 @@
-# -*- coding: utf-8 -*-
 #
 # futures documentation build configuration file, created by
 # sphinx-quickstart on Wed Jun  3 19:35:34 2009.
@@ -37,8 +36,8 @@ source_suffix = '.rst'
 master_doc = 'index'
 
 # General information about the project.
-project = u'futures'
-copyright = u'2009-2011, Brian Quinlan'
+project = 'futures'
+copyright = '2009-2011, Brian Quinlan'
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
@@ -172,8 +171,8 @@ htmlhelp_basename = 'futuresdoc'
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-  ('index', 'futures.tex', u'futures Documentation',
-   u'Brian Quinlan', 'manual'),
+  ('index', 'futures.tex', 'futures Documentation',
+   'Brian Quinlan', 'manual'),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
diff --git a/python/futures/primes.py b/python/futures/primes.py
index 0da2b3e64c..a24a6b7f01 100644
--- a/python/futures/primes.py
+++ b/python/futures/primes.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 import math
 import time
 import sys
